//------------------------------------------------------
// module  : FunctionMCD.cc
// auteur  : Redha Touati and Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionMCD.h"
#include "MCD.h"

//-------------------------//
//-- Matrice de Flottant --//
//-------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(long int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; 
 }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//---------------------------//
//--- Liberation memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}


//--------------------//
//-- Matrix Gestion --//
//--------------------//
//----------------------------------------------------------
// copie une matrice dans une autre
//----------------------------------------------------------
void CopyMat(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat1[i][j]=mat2[i][j]; 
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (max) mat[i][j]*=(GREY_LEVEL/max);      
}

//----------------------------------------------------------
// calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
int DiffMatNb(float** pmatl1,float** pmatl2,int lgth,int wdth)
{
 int i,j;
 int chg;

 //>Compte NbChgt
 chg=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (pmatl1[i][j]!=pmatl2[i][j]) chg++; 
       
 return chg;
}


//--------------//
// RANDOM ------//
//--------------//
//----------------------------------------------------------
// retourne un nombre aleatoire entre zero et un
//----------------------------------------------------------
float randomize(void)
{ return ((float)rand()/RAND_MAX); }


//----------//
//-- FILE --//
//----------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;
  if (0) printf("[%d][%c]",temp,*tempc);

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en ppm)             
//----------------------------------------------------------
void LoadImagePpm(char* path,float*** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char varb,varv,varr;

  char stringTmp1[200],stringTmp2[200];
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".ppm")==NULL) strcat(path,".ppm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic); //P6
  tempc=fgets(stringTmp2,100,fic); //Comment

  for(;;)
    { if (((int)stringTmp2[0]==10)||((int)stringTmp2[0]==35))
      tempc=fgets(stringTmp2,100,fic); 
      else break; }

  temp=sscanf(tempc," %d %d",&ta1,&ta2);
  temp=fscanf(fic," %d\n",&ta3);

  //printf("\n > Entete: %s  %d %d \n %d\n",stringTmp1,ta1,ta2,ta3);
  if (0) printf("[%d][%c]",temp,*tempc);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<(wdth*3);j+=3)  
    { temp=fread(&varr,1,1,fic);
      temp=fread(&varv,1,1,fic);
      temp=fread(&varb,1,1,fic);    
      img[0][i][j/3]=varr;        
      img[1][i][j/3]=varv;        
      img[2][i][j/3]=varb; }      

  //fermeture du fichier
  fclose(fic);
 }

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
    printf("\n >> Sauvegarde dans -> %s au format pgm",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}

//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format ppm        
//----------------------------------------------------------
void SaveImagePpm(char* Path_out,char* Name,float*** matrvb,int wdth,int lgth)
 {
  int i,j;
  char buff[200];
  FILE* fuser;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,".ppm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n >> Sauvegarde dans -> %s au format %s",buff,".ppm");
  fflush(stdout);

  //sauvegarde de l'entete
  fprintf(fuser,"P6");
  fprintf(fuser,"\n# IMG Module");
  fprintf(fuser,"\n%d %d",lgth,wdth);
  fprintf(fuser,"\n255\n");

  //enregistrement
  for(i=0;i<wdth;i++) for(j=0;j<lgth;j++) 
    { fprintf(fuser,"%c",(char)matrvb[0][i][j]);
      fprintf(fuser,"%c",(char)matrvb[1][i][j]);
      fprintf(fuser,"%c",(char)matrvb[2][i][j]); }
       
  //fermeture fichier
   fclose(fuser); 
 }

//--------------------------------
//---GRAPH------------------------
//--------------------------------
//------------------------------------------------
// Compute_NonLocalGraph <2>
//------------------------------------------------
void CompNonLocGraph2(float** ImgBef,float** ImgAft,float*** NonLocGr,int lgth,int wdth,int sw,int flgOpt,int flgDst)
{
 int i,j,k,l;  
 int c_n;                                              
 int posr,posc;
 float dst;
 int NbConx;

 //>Presentation
 printf("\n > NonLocalGraph (2)(Non-Toroidal)_Setting_[Sz:%d DCT/Opt:%d Dist:%d]",sw,flgOpt,flgDst);
 fflush(stdout);
 
    //------------------------------------------------
    //--- Compute_The_Graph
    //------------------------------------------------
    NbConx=0;
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
       {
        c_n=0; 
        //_Windows_Search
        for(k=0;k<sw;k++) for(l=0;l<sw;l++)
	if ( ((!k)&&((!l)||(l==sw/2)||(l==sw-1))) || ((k==sw/2)&&(!l)) || ((k==sw/2)&&(l==sw-1)) || ((k==sw-1)&&((!l)||(l==sw/2)||(l==sw-1))) )
           {	     
            //_Fill_The_Graph
            posr = i - (sw/2) + k;
            posc = j - (sw/2) + l;
            if (posr<0)         posr=0;
            if (posr>(lgth-1))  posr=(lgth-1);
            if (posc<0)         posc=0;
            if (posc>(wdth-1))  posc=(wdth-1);

            //_Distance__Pair[row=i;col=j]_[row=posr;col=posc]
	    dst=0.0;

	    //>DCT
	    if (flgOpt==16) dst=MyPairwiseDistanceDCT(ImgBef,ImgAft,i,j,posr,posc,lgth,wdth,16,flgDst);
	    //if (flgOpt==16) dst=MyPairwiseDistanceDCT_(ImgBef,ImgAft,i,j,posr,posc,lgth,wdth,16,flgDst);
	    
            //_Store_Infos
            NonLocGr[0][c_n][i*wdth+j]=posr; //Row
            NonLocGr[1][c_n][i*wdth+j]=posc; //Col
	    NonLocGr[2][c_n][i*wdth+j]=dst;  //Distance
            ++c_n;
           }
	NbConx=c_n;
       }//--EndGraph----------------------------------------------
  printf("[NbCnx=%d]",NbConx);
}

//---------------
//--- NRJ --------
//---------------
//----------------------------------------------------------
// Compute NRJ <Exp(alpha0)::Norm(alpha1,var1)>
//----------------------------------------------------------
float NRJ_EG(float*** NonLocGr,int nbcnxion,int lgth,int wdth,\
	       float alpha0,float alpha1,float var1,float HYP,float** MatSegInit)
{
 int i,j,k,l;
 int posr,posc,Neigh;
 double dist,Nrj,U;
 double LOG_ALPHA0=log(alpha0);
 const int SzWP=3;
 
 //>Presentation
 //printf("\n >NRJ [Img<%d:%d>::Cnx=%d] Prior[%d::%.2f]",lgth,wdth,nbcnxion,SzWP,HYP);
 //fflush(stdout);

 //>NRJ
 //======================================
  Nrj=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
       U=0.0;
       //:Compute_Nrj_Likelihood
       for(k=0;k<nbcnxion;k++)
          { posr=NonLocGr[0][k][i*wdth+j]; 
            posc=NonLocGr[1][k][i*wdth+j]; 
            dist=NonLocGr[2][k][i*wdth+j];	    
            if ((MatSegInit[posr][posc]==1)&&(MatSegInit[i][j]==1)) U+=LOG_ALPHA0+(dist/alpha0);	    
	    if ((MatSegInit[posr][posc]==0)&&(MatSegInit[i][j]==0)) U+=LOG_ALPHA0+(dist/alpha0);
	    if ((MatSegInit[posr][posc]==1)&&(MatSegInit[i][j]==0)) U+=-log(funcgauss(dist,1.0,alpha1,var1));          
	    if ((MatSegInit[posr][posc]==0)&&(MatSegInit[i][j]==1)) U+=-log(funcgauss(dist,1.0,alpha1,var1));
	  } 	    	    
        U/=nbcnxion;

       //:Compute_Nrj_Prior
       Neigh=0;
       for(k=0;k<SzWP;k++) for(l=0;l<SzWP;l++)
	  { if ((k==(SzWP/2))&&(l==(SzWP/2))) continue;
	    posr=i-(SzWP/2)+k;
            posc=j-(SzWP/2)+l;
            if (posr<0)          posr+=lgth;
            if (posr>(lgth-1))   posr-=lgth;  
            if (posc<0)          posc+=wdth;
            if (posc>(wdth-1))   posc-=wdth;
	    if (MatSegInit[posr][posc]!=MatSegInit[i][j]) Neigh++; }

       //:Compute_Total_Nrj
       U+=HYP*Neigh;
       Nrj+=U;
     }

  //Return
  return Nrj;
}

//----------------------------------------------------------
// function Normal
//----------------------------------------------------------
float funcgauss(float pix,float coef,float moy,float var)
{
 return ((coef)*(1/(sqrt(2*PI*var)))*exp(-1*(CARRE(pix-moy)/(2*var))));
}

float MinusLogfuncgauss(float pix,float moy,float var)
{
 return (0.5*log(2*PI*var))+(CARRE(pix-moy)/(2*var));
}

//----------------------------------------------------------
// function::Exponentiel
//----------------------------------------------------------
float funcexpon(float pix,float coef,float alpha)
{
 return ((coef)*(1/(alpha))*exp(-1*(float)pix/alpha));
}

float MinusLogfuncexpon(float pix,float alpha)
{
 return ((pix/alpha)+log(alpha));
}

//-------------------------
//-------------------------
//---RECUIT SIMULE --------
//-------------------------
//-------------------------
//Retourne 1 avec probabilite p: ou sinon 0
int Flip(float p)
{
  if(randomize()<=p) return(1);
  return(0);
}

//Calcule la probabilite de chacune des deux classes pour une temperature t, 
//  a partir des deux valeurs du champs de Gibbs
void ComputeProb(float* prob,float* energy,float temp)
{
  int k;
  float min, sum;
  min=(energy[0]<energy[1]?energy[0]:energy[1]);
  
  sum=0.0;
  for(k=0;k<2;k++)
    { prob[k]=exp(-(energy[k]-min)/temp);
      sum+=prob[k]; }
  
  for(k=0;k<2;k++) prob[k]/=sum;
}

//Choisi une des deux classes selon les probabilites des classes
float ChooseLabelSA(float* prob)
{
 if (Flip(prob[0])) return 0.0;
 return 1.0;
}

//---------------------
//---------------------
//---REDUCTION SIZE----
//---------------------
//---------------------
//----------------------------------------------------------
// multiresolution
//----------------------------------------------------------
void Multires(float** MatIn,int lgth,int wdth,float** MatOut,int scale)
{ 
 int i,j,ii,jj;
 int row,col;
 float sum_pix;
 int cpt;
 int lgthR,wdthR;
 lgthR=lgth/scale;
 wdthR=wdth/scale;
 //printf("\n [scale::%d]  [%d::%d > %d::%d] \n",scale,lgth,wdth,lgthR,wdthR);
 //fflush(stdout);

  //Loop
 for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    {  row=(int)(i*scale);
       col=(int)(j*scale);
       sum_pix=0.0;  
       cpt=0;
       for(ii=row;ii<(row+scale);ii++) for(jj=col;jj<(col+scale);jj++)
	  { sum_pix+=MatIn[ii][jj];  cpt++; }	            
       if (cpt!=0) sum_pix/=cpt;    
       if ((i<lgthR)&&(j<wdthR)) MatOut[i][j]=(int)(sum_pix+0.5); }
}


//----------------------------------------------------------
// DecreasedSize
//----------------------------------------------------------
void DecreasedSize(float*** ImgB,float*** ImgA,float*** ImgG,int* lgth,int* wdth,int* scale)
{
 int i,j,k;
 int ScaleFactor;
 int length,width;
 int lgthR,wdthR;

 length=(*lgth);
 width=(*wdth);
 ScaleFactor=(int)(MAX(length,width)/MAXLGTHIMG);
 //printf(" [%d:%d]:Scale=%d",length,width,ScaleFactor);
 //fflush(stdout);
 lgthR=length/ScaleFactor;
 wdthR=width/ScaleFactor;

  //>AllocationMemory
 float*** MatImgB=fmatrix_allocate_3d(TROIS,lgthR,wdthR);
 float*** MatImgA=fmatrix_allocate_3d(TROIS,lgthR,wdthR);	
 float*** MatImgG=fmatrix_allocate_3d(TROIS,lgthR,wdthR);

 //>Reduction_[Before-After]-[GroundTruth]
 Multires(ImgB[0],length,width,MatImgB[0],ScaleFactor);
 Multires(ImgA[0],length,width,MatImgA[0],ScaleFactor);
 Multires(ImgB[1],length,width,MatImgB[1],ScaleFactor);
 Multires(ImgA[1],length,width,MatImgA[1],ScaleFactor);
 Multires(ImgB[2],length,width,MatImgB[2],ScaleFactor);
 Multires(ImgA[2],length,width,MatImgA[2],ScaleFactor);

 Multires(ImgG[0],length,width,MatImgG[0],ScaleFactor);
 Multires(ImgG[1],length,width,MatImgG[1],ScaleFactor);
 Multires(ImgG[2],length,width,MatImgG[2],ScaleFactor);

 //>Binarisation-[GroundTruth]
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { if (MatImgG[k][i][j]<128) MatImgG[k][i][j]=0;
      else MatImgG[k][i][j]=255; }

 //>In_PPM
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { ImgB[k][i][j]=MatImgB[k][i][j];
      ImgA[k][i][j]=MatImgA[k][i][j];
      ImgG[k][i][j]=MatImgG[k][i][j]; }	

 //>DEBUG
 //SaveImagePpm((char*)"",(char*)"PictB",ImgB,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictA",ImgA,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictG",ImgG,lgthR,wdthR);
 //exit(-1);
 
 //>End
 if (MatImgB) free_fmatrix_3d(MatImgB,TROIS);
 if (MatImgA) free_fmatrix_3d(MatImgA,TROIS);
 if (MatImgG) free_fmatrix_3d(MatImgG,TROIS);
 (*lgth)=lgthR;
 (*wdth)=wdthR;
 (*scale)=ScaleFactor;
}

//----------------------------------------------------------
// DecreasedSizeByTwo
//----------------------------------------------------------
void DecreasedSizeByTwo(float*** ImgB,float*** ImgA,float*** ImgG,int* lgth,int* wdth,int* scale)
{
 int i,j,k;
 int ScaleFactor;
 int length,width;
 int lgthR,wdthR;

 printf(" > DecreasedSizeByTwo");
 length=(*lgth);
 width=(*wdth);
 ScaleFactor=2;
 //printf(" [%d:%d]:Scale=%d",length,width,ScaleFactor);
 //fflush(stdout);
 lgthR=length/ScaleFactor;
 wdthR=width/ScaleFactor;

  //>AllocationMemory
 float*** MatImgB=fmatrix_allocate_3d(TROIS,lgthR,wdthR);
 float*** MatImgA=fmatrix_allocate_3d(TROIS,lgthR,wdthR);	
 float*** MatImgG=fmatrix_allocate_3d(TROIS,lgthR,wdthR);

 //>Reduction_[Before-After]-[GroundTruth]
 Multires(ImgB[0],length,width,MatImgB[0],ScaleFactor);
 Multires(ImgA[0],length,width,MatImgA[0],ScaleFactor);
 Multires(ImgB[1],length,width,MatImgB[1],ScaleFactor);
 Multires(ImgA[1],length,width,MatImgA[1],ScaleFactor);
 Multires(ImgB[2],length,width,MatImgB[2],ScaleFactor);
 Multires(ImgA[2],length,width,MatImgA[2],ScaleFactor);

 Multires(ImgG[0],length,width,MatImgG[0],ScaleFactor);
 Multires(ImgG[1],length,width,MatImgG[1],ScaleFactor);
 Multires(ImgG[2],length,width,MatImgG[2],ScaleFactor);

 //>Binarisation-[GroundTruth]
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { if (MatImgG[k][i][j]<128) MatImgG[k][i][j]=0;
      else MatImgG[k][i][j]=255; }

 //>In_PPM
 for(k=0;k<TROIS;k++) for(i=0;i<lgthR;i++) for(j=0;j<wdthR;j++)
    { ImgB[k][i][j]=MatImgB[k][i][j];
      ImgA[k][i][j]=MatImgA[k][i][j];
      ImgG[k][i][j]=MatImgG[k][i][j]; }	

 //>DEBUG
 //SaveImagePpm((char*)"",(char*)"PictB",ImgB,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictA",ImgA,lgthR,wdthR);
 //SaveImagePpm((char*)"",(char*)"PictG",ImgG,lgthR,wdthR);
 //exit(-1);
 
 //>End
 if (MatImgB) free_fmatrix_3d(MatImgB,TROIS);
 if (MatImgA) free_fmatrix_3d(MatImgA,TROIS);
 if (MatImgG) free_fmatrix_3d(MatImgG,TROIS);
 (*lgth)=lgthR;
 (*wdth)=wdthR;
 (*scale)=(*scale)*ScaleFactor;
}

 
//-----------------//
//-- HISTO MANIP --//
//-----------------//
//-----------------------------------------------------
// calcul de l'histogramme                           
//-----------------------------------------------------
void Compute_histo(float** img,int lgth,int wdth,float* hist)
{
 int i,j;

  //initialisation
  for(i=0;i<GREY_LEVEL;i++) hist[i]=0.0;

  //calcul de l'histogramme
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if ((img[i][j]>0)&&(img[i][j]<GREY_LEVEL))
       hist[(int)(img[i][j]+0.5)]++;
 
  //normalisation
  for(i=0;i<GREY_LEVEL;i++)  hist[i]/=(float)(wdth*lgth);
}


//------------------------------------------------
// Specif. histo[img_in] sur histo[img_out]
// (img_in possédant le même histo que img_out)
//------------------------------------------------
void SpecifHisto(float** img_in,int lgth_in,int wdth_in,float** img_out,int lgth_out,int wdth_out)
 {
  int i,j;
  float Hist_Img1[GREY_LEVEL+1],Hist_Img2[GREY_LEVEL+1];
  float Vect_Img1[GREY_LEVEL+1],Vect_Img2[GREY_LEVEL+1],Vect_Img3[GREY_LEVEL+1];

  //--------Egalisation------------
  //Initialisation
  for(i=0;i<=GREY_LEVEL;i++)
    { Hist_Img1[i]=Hist_Img2[i]=0.0;
      Vect_Img1[i]=Vect_Img2[i]=Vect_Img3[i]=0.0; }

  //Calcule histo[img_in]
  Compute_histo(img_in,lgth_in,wdth_in,Hist_Img1);

  //Calcule T::fonctRepartition[img_in]>Vect_Img1
  for(i=0;i<=GREY_LEVEL;i++)
    { if (i>0)  Vect_Img1[i]=Vect_Img1[i-1]+Hist_Img1[i];
      else      Vect_Img1[i]=Vect_Img1[i]; }
  for(i=0;i<=GREY_LEVEL;i++) Vect_Img1[i]=(int)((Vect_Img1[i]*255)+0.5);

  //Egalise histo[img_in]
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++)
     img_in[i][j]=(int)Vect_Img1[(int)(img_in[i][j])];

  //========================

  //Calcule histo[img_out]
  Compute_histo(img_out,lgth_out,wdth_out,Hist_Img2);

  //Calcule G::fonctRepartition[img_out]>Vect_Img2
  for(i=0;i<=GREY_LEVEL;i++)
    { if (i>0)  Vect_Img2[i]=Vect_Img2[i-1]+Hist_Img2[i];
      else      Vect_Img2[i]=Vect_Img2[i]; }
  for(i=0;i<=GREY_LEVEL;i++) Vect_Img2[i]=(int)((Vect_Img2[i]*255)+0.5);

  //Calcule G^-1 (avec G=Vect_Img2)>Vect_Img3
  for(i=0;i<=GREY_LEVEL;i++)
    { Vect_Img3[i]=i;
      for(j=GREY_LEVEL;j>0;j--) if (Vect_Img2[j]>i) Vect_Img3[i]=j; }

  //Specif. histo[img_in]>histo[img_out]
  for(i=0;i<lgth_in;i++) for(j=0;j<wdth_in;j++)
     img_in[i][j]=(int)Vect_Img3[(int)(img_in[i][j])];
 }

//------------------------------------------------
// Double Specif. histo [img_in::img_out]
//------------------------------------------------
void DoubleSpecifHisto(float** img1,float** img2,int lgth,int wdth)
{
 //>DoubleHistoSpecif
 SpecifHisto(img1,lgth,wdth,img2,lgth,wdth);
 SpecifHisto(img2,lgth,wdth,img1,lgth,wdth);
}


//---------//
//---DCT---//
//---------//
//----------------------//
// Made by T. OORA      //
//----------------------//
#define C16_1R   0.35185093438159561476
#define C16_1I   0.03465429229977286565
#define C16_2R   0.34675996133053686546
#define C16_2I   0.06897484482073575308
#define C16_3R   0.33832950029358816957
#define C16_3I   0.10263113188058934529
#define C16_4R   0.32664074121909413196
#define C16_4I   0.13529902503654924610
#define C16_5R   0.31180625324666780814
#define C16_5I   0.16666391461943662432
#define C16_6R   0.29396890060483967924
#define C16_6I   0.19642373959677554532
#define C16_7R   0.27330046675043937206
#define C16_7I   0.22429189658565907106
#define C16_8R   0.25
#define W16_4R   0.92387953251128675613
#define W16_4I   0.38268343236508977173
#define W16_8R   0.70710678118654752440

void ddct16x16s(int isgn,float **a)
{
    int j;
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i;
    float x4r, x4i, x5r, x5i, x6r, x6i, x7r, x7i;
    float xr, xi;
    
    if (isgn < 0) {
        for (j = 0; j <= 15; j++) {
            x4r = a[0][j] - a[15][j];
            xr = a[0][j] + a[15][j];
            x4i = a[8][j] - a[7][j];
            xi = a[8][j] + a[7][j];
            x0r = xr + xi;
            x0i = xr - xi;
            x5r = a[2][j] - a[13][j];
            xr = a[2][j] + a[13][j];
            x5i = a[10][j] - a[5][j];
            xi = a[10][j] + a[5][j];
            x1r = xr + xi;
            x1i = xr - xi;
            x6r = a[4][j] - a[11][j];
            xr = a[4][j] + a[11][j];
            x6i = a[12][j] - a[3][j];
            xi = a[12][j] + a[3][j];
            x2r = xr + xi;
            x2i = xr - xi;
            x7r = a[6][j] - a[9][j];
            xr = a[6][j] + a[9][j];
            x7i = a[14][j] - a[1][j];
            xi = a[14][j] + a[1][j];
            x3r = xr + xi;
            x3i = xr - xi;
            xr = x0r + x2r;
            xi = x1r + x3r;
            a[0][j] = C16_8R * (xr + xi);
            a[8][j] = C16_8R * (xr - xi);
            xr = x0r - x2r;
            xi = x1r - x3r;
            a[4][j] = C16_4R * xr - C16_4I * xi;
            a[12][j] = C16_4R * xi + C16_4I * xr;
            x0r = W16_8R * (x1i - x3i);
            x2r = W16_8R * (x1i + x3i);
            xr = x0i + x0r;
            xi = x2r + x2i;
            a[2][j] = C16_2R * xr - C16_2I * xi;
            a[14][j] = C16_2R * xi + C16_2I * xr;
            xr = x0i - x0r;
            xi = x2r - x2i;
            a[6][j] = C16_6R * xr - C16_6I * xi;
            a[10][j] = C16_6R * xi + C16_6I * xr;
            xr = W16_8R * (x6r - x6i);
            xi = W16_8R * (x6i + x6r);
            x6r = x4r - xr;
            x6i = x4i - xi;
            x4r += xr;
            x4i += xi;
            xr = W16_4I * x7r - W16_4R * x7i;
            xi = W16_4I * x7i + W16_4R * x7r;
            x7r = W16_4R * x5r - W16_4I * x5i;
            x7i = W16_4R * x5i + W16_4I * x5r;
            x5r = x7r + xr;
            x5i = x7i + xi;
            x7r -= xr;
            x7i -= xi;
            xr = x4r + x5r;
            xi = x5i + x4i;
            a[1][j] = C16_1R * xr - C16_1I * xi;
            a[15][j] = C16_1R * xi + C16_1I * xr;
            xr = x4r - x5r;
            xi = x5i - x4i;
            a[7][j] = C16_7R * xr - C16_7I * xi;
            a[9][j] = C16_7R * xi + C16_7I * xr;
            xr = x6r - x7i;
            xi = x7r + x6i;
            a[5][j] = C16_5R * xr - C16_5I * xi;
            a[11][j] = C16_5R * xi + C16_5I * xr;
            xr = x6r + x7i;
            xi = x7r - x6i;
            a[3][j] = C16_3R * xr - C16_3I * xi;
            a[13][j] = C16_3R * xi + C16_3I * xr;
        }
        for (j = 0; j <= 15; j++) {
            x4r = a[j][0] - a[j][15];
            xr = a[j][0] + a[j][15];
            x4i = a[j][8] - a[j][7];
            xi = a[j][8] + a[j][7];
            x0r = xr + xi;
            x0i = xr - xi;
            x5r = a[j][2] - a[j][13];
            xr = a[j][2] + a[j][13];
            x5i = a[j][10] - a[j][5];
            xi = a[j][10] + a[j][5];
            x1r = xr + xi;
            x1i = xr - xi;
            x6r = a[j][4] - a[j][11];
            xr = a[j][4] + a[j][11];
            x6i = a[j][12] - a[j][3];
            xi = a[j][12] + a[j][3];
            x2r = xr + xi;
            x2i = xr - xi;
            x7r = a[j][6] - a[j][9];
            xr = a[j][6] + a[j][9];
            x7i = a[j][14] - a[j][1];
            xi = a[j][14] + a[j][1];
            x3r = xr + xi;
            x3i = xr - xi;
            xr = x0r + x2r;
            xi = x1r + x3r;
            a[j][0] = C16_8R * (xr + xi);
            a[j][8] = C16_8R * (xr - xi);
            xr = x0r - x2r;
            xi = x1r - x3r;
            a[j][4] = C16_4R * xr - C16_4I * xi;
            a[j][12] = C16_4R * xi + C16_4I * xr;
            x0r = W16_8R * (x1i - x3i);
            x2r = W16_8R * (x1i + x3i);
            xr = x0i + x0r;
            xi = x2r + x2i;
            a[j][2] = C16_2R * xr - C16_2I * xi;
            a[j][14] = C16_2R * xi + C16_2I * xr;
            xr = x0i - x0r;
            xi = x2r - x2i;
            a[j][6] = C16_6R * xr - C16_6I * xi;
            a[j][10] = C16_6R * xi + C16_6I * xr;
            xr = W16_8R * (x6r - x6i);
            xi = W16_8R * (x6i + x6r);
            x6r = x4r - xr;
            x6i = x4i - xi;
            x4r += xr;
            x4i += xi;
            xr = W16_4I * x7r - W16_4R * x7i;
            xi = W16_4I * x7i + W16_4R * x7r;
            x7r = W16_4R * x5r - W16_4I * x5i;
            x7i = W16_4R * x5i + W16_4I * x5r;
            x5r = x7r + xr;
            x5i = x7i + xi;
            x7r -= xr;
            x7i -= xi;
            xr = x4r + x5r;
            xi = x5i + x4i;
            a[j][1] = C16_1R * xr - C16_1I * xi;
            a[j][15] = C16_1R * xi + C16_1I * xr;
            xr = x4r - x5r;
            xi = x5i - x4i;
            a[j][7] = C16_7R * xr - C16_7I * xi;
            a[j][9] = C16_7R * xi + C16_7I * xr;
            xr = x6r - x7i;
            xi = x7r + x6i;
            a[j][5] = C16_5R * xr - C16_5I * xi;
            a[j][11] = C16_5R * xi + C16_5I * xr;
            xr = x6r + x7i;
            xi = x7r - x6i;
            a[j][3] = C16_3R * xr - C16_3I * xi;
            a[j][13] = C16_3R * xi + C16_3I * xr;
        }
    } else {
        for (j = 0; j <= 15; j++) {
            x5r = C16_1R * a[1][j] + C16_1I * a[15][j];
            x5i = C16_1R * a[15][j] - C16_1I * a[1][j];
            xr = C16_7R * a[7][j] + C16_7I * a[9][j];
            xi = C16_7R * a[9][j] - C16_7I * a[7][j];
            x4r = x5r + xr;
            x4i = x5i - xi;
            x5r -= xr;
            x5i += xi;
            x7r = C16_5R * a[5][j] + C16_5I * a[11][j];
            x7i = C16_5R * a[11][j] - C16_5I * a[5][j];
            xr = C16_3R * a[3][j] + C16_3I * a[13][j];
            xi = C16_3R * a[13][j] - C16_3I * a[3][j];
            x6r = x7r + xr;
            x6i = x7i - xi;
            x7r -= xr;
            x7i += xi;
            xr = x4r - x6r;
            xi = x4i - x6i;
            x4r += x6r;
            x4i += x6i;
            x6r = W16_8R * (xi + xr);
            x6i = W16_8R * (xi - xr);
            xr = x5r + x7i;
            xi = x5i - x7r;
            x5r -= x7i;
            x5i += x7r;
            x7r = W16_4I * x5r + W16_4R * x5i;
            x7i = W16_4I * x5i - W16_4R * x5r;
            x5r = W16_4R * xr + W16_4I * xi;
            x5i = W16_4R * xi - W16_4I * xr;
            xr = C16_4R * a[4][j] + C16_4I * a[12][j];
            xi = C16_4R * a[12][j] - C16_4I * a[4][j];
            x2r = C16_8R * (a[0][j] + a[8][j]);
            x3r = C16_8R * (a[0][j] - a[8][j]);
            x0r = x2r + xr;
            x1r = x3r + xi;
            x2r -= xr;
            x3r -= xi;
            x0i = C16_2R * a[2][j] + C16_2I * a[14][j];
            x2i = C16_2R * a[14][j] - C16_2I * a[2][j];
            x1i = C16_6R * a[6][j] + C16_6I * a[10][j];
            x3i = C16_6R * a[10][j] - C16_6I * a[6][j];
            xr = x0i - x1i;
            xi = x2i + x3i;
            x0i += x1i;
            x2i -= x3i;
            x1i = W16_8R * (xi + xr);
            x3i = W16_8R * (xi - xr);
            xr = x0r + x0i;
            xi = x0r - x0i;
            a[0][j] = xr + x4r;
            a[15][j] = xr - x4r;
            a[8][j] = xi + x4i;
            a[7][j] = xi - x4i;
            xr = x1r + x1i;
            xi = x1r - x1i;
            a[2][j] = xr + x5r;
            a[13][j] = xr - x5r;
            a[10][j] = xi + x5i;
            a[5][j] = xi - x5i;
            xr = x2r + x2i;
            xi = x2r - x2i;
            a[4][j] = xr + x6r;
            a[11][j] = xr - x6r;
            a[12][j] = xi + x6i;
            a[3][j] = xi - x6i;
            xr = x3r + x3i;
            xi = x3r - x3i;
            a[6][j] = xr + x7r;
            a[9][j] = xr - x7r;
            a[14][j] = xi + x7i;
            a[1][j] = xi - x7i;
        }
        for (j = 0; j <= 15; j++) {
            x5r = C16_1R * a[j][1] + C16_1I * a[j][15];
            x5i = C16_1R * a[j][15] - C16_1I * a[j][1];
            xr = C16_7R * a[j][7] + C16_7I * a[j][9];
            xi = C16_7R * a[j][9] - C16_7I * a[j][7];
            x4r = x5r + xr;
            x4i = x5i - xi;
            x5r -= xr;
            x5i += xi;
            x7r = C16_5R * a[j][5] + C16_5I * a[j][11];
            x7i = C16_5R * a[j][11] - C16_5I * a[j][5];
            xr = C16_3R * a[j][3] + C16_3I * a[j][13];
            xi = C16_3R * a[j][13] - C16_3I * a[j][3];
            x6r = x7r + xr;
            x6i = x7i - xi;
            x7r -= xr;
            x7i += xi;
            xr = x4r - x6r;
            xi = x4i - x6i;
            x4r += x6r;
            x4i += x6i;
            x6r = W16_8R * (xi + xr);
            x6i = W16_8R * (xi - xr);
            xr = x5r + x7i;
            xi = x5i - x7r;
            x5r -= x7i;
            x5i += x7r;
            x7r = W16_4I * x5r + W16_4R * x5i;
            x7i = W16_4I * x5i - W16_4R * x5r;
            x5r = W16_4R * xr + W16_4I * xi;
            x5i = W16_4R * xi - W16_4I * xr;
            xr = C16_4R * a[j][4] + C16_4I * a[j][12];
            xi = C16_4R * a[j][12] - C16_4I * a[j][4];
            x2r = C16_8R * (a[j][0] + a[j][8]);
            x3r = C16_8R * (a[j][0] - a[j][8]);
            x0r = x2r + xr;
            x1r = x3r + xi;
            x2r -= xr;
            x3r -= xi;
            x0i = C16_2R * a[j][2] + C16_2I * a[j][14];
            x2i = C16_2R * a[j][14] - C16_2I * a[j][2];
            x1i = C16_6R * a[j][6] + C16_6I * a[j][10];
            x3i = C16_6R * a[j][10] - C16_6I * a[j][6];
            xr = x0i - x1i;
            xi = x2i + x3i;
            x0i += x1i;
            x2i -= x3i;
            x1i = W16_8R * (xi + xr);
            x3i = W16_8R * (xi - xr);
            xr = x0r + x0i;
            xi = x0r - x0i;
            a[j][0] = xr + x4r;
            a[j][15] = xr - x4r;
            a[j][8] = xi + x4i;
            a[j][7] = xi - x4i;
            xr = x1r + x1i;
            xi = x1r - x1i;
            a[j][2] = xr + x5r;
            a[j][13] = xr - x5r;
            a[j][10] = xi + x5i;
            a[j][5] = xi - x5i;
            xr = x2r + x2i;
            xi = x2r - x2i;
            a[j][4] = xr + x6r;
            a[j][11] = xr - x6r;
            a[j][12] = xi + x6i;
            a[j][3] = xi - x6i;
            xr = x3r + x3i;
            xi = x3r - x3i;
            a[j][6] = xr + x7r;
            a[j][9] = xr - x7r;
            a[j][14] = xi + x7i;
            a[j][1] = xi - x7i;
        }
    }
}

//----------------------------------------------------------
// DCT_Spectrum
//----------------------------------------------------------
void DCT_Spectrum(float** img,int lgth,int wdth,int row,int col,float** SquWin,int SZSPECT)
{
 int k,l;
 int posr,posc;

 //>Data
 for(k=0;k<SZSPECT;k++) for(l=0;l<SZSPECT;l++) 
    { posr=row-(SZSPECT/2)+k;
      posc=col-(SZSPECT/2)+l;
      if (posr<0)         posr+=lgth;
      if (posr>(lgth-1))  posr-=lgth; 
      if (posc<0)         posc+=wdth;
      if (posc>(wdth-1))  posc-=wdth;
      SquWin[k][l]=img[posr][posc]; }

 //>DCT
 //if (SZSPECT==8)  ddct8x8s(-1,SquWin);
 if (SZSPECT==16) ddct16x16s(-1,SquWin);

 //>Module
 for(k=0;k<SZSPECT;k++) for(l=0;l<SZSPECT;l++) SquWin[k][l]=fabs(SquWin[k][l]);		       
}

/*----------------------------------------------------*/
/* BilinearInterpolation                              */
/*----------------------------------------------------*/
float BilinearInterp(float** img,int lgth,int wdth,float row,float col)  
{
 int col_inf,col_sup;
 int row_inf,row_sup;
 float t,u;
 float ng;

 col_inf=(int)(col);
 col_sup=(int)(col+1);
 row_inf=(int)(row);
 row_sup=(int)(row+1);
 t=(col-col_inf)/(col_sup-col_inf);
 u=(row-row_inf)/(row_sup-row_inf);

 ng=0.0;
 if ((col_inf>=0)&&(row_inf>=0)&&(col_sup<wdth)&&(row_sup<lgth))
    { ng=(1-t)*(1-u)*img[row_inf][col_inf];
      ng+=t*(1-u)*img[row_inf][col_sup];
      ng+=t*u*img[row_sup][col_sup];
      ng+=(1-t)*u*img[row_sup][col_inf]; }

 //DEBUG
 //if (isnan(ng)) printf("\n [%.2f:::%d:%d][%.2f:::%d:%d]::[%.3f]",row,row_inf,row_sup,col,col_inf,col_sup,ng);

 return ng;  
}

/*----------------------------------------------------*/
/* CircularInteg                                      */
/*----------------------------------------------------*/
void CircularInteg(float** SpctrImg,int Szw,float* VctSpctr)
{
 int k,l; 
 float dist;
 const int NBCIRC=8;
 
 for(k=0;k<(Szw/2);k++)
    { dist=0.0;
      for(l=0;l<=NBCIRC;l++) dist+=BilinearInterp(SpctrImg,Szw,Szw,k*sin(l*PI/(float)(2.0*NBCIRC)),k*cos(l*PI/(float)(2.0*NBCIRC)));
      dist/=(float)(NBCIRC*Szw);
      VctSpctr[k]=dist; }    
}

/*----------------------------------------------------*/
/* CircularInteg (step:0.5)                           */
/*----------------------------------------------------*/
void CircularInteg_(float** SpctrImg,int Szw,float* VctSpctr)
{
 int k,l;
 float dist;
 
 //const int NBCIRC=8;
 //for(k=0;k<Szw;k++)
 //   { dist=0.0;
 //     for(l=0;l<=NBCIRC;l++)
 //     { dist+=BilinearInterp(SpctrImg,Szw,Szw,0.5*(float)k*sin(l*PI/(float)(2.0*NBCIRC)),0.5*(float)k*cos(l*PI/(float)(2.0*NBCIRC))); }
 //     dist/=(float)(NBCIRC*Szw);
 //     VctSpctr[k]=dist; }

 const int NBCIRC=16;
 for(k=0;k<(Szw/2);k++)
    { dist=0.0;
      for(l=0;l<=NBCIRC;l++)
      { dist+=BilinearInterp(SpctrImg,Szw,Szw,k*sin(l*PI/(float)(2.0*NBCIRC)),k*cos(l*PI/(float)(2.0*NBCIRC))); }
      dist/=(float)(NBCIRC*Szw);
      VctSpctr[k]=dist; }
}

//----------------------------------------------------------
//  MyPairwiseDistanceDCT
//----------------------------------------------------------
float MyPairwiseDistanceDCT(float** ImgB,float** ImgA,int ci,int cj,int posr,int posc,int lgth,int wdth,int Szw,int Flg)
{
 int i,j,k;
 float dist,distB,distA;
 int FlagSzw=0;

 //>Szw=1
 if (Szw==1) { Szw=8; FlagSzw=1; }
     
 //>AllocateMemory
 float** MatSpectrAij=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrArc=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrBij=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrBrc=fmatrix_allocate_2d(Szw,Szw);
 float* VctSpectrAij=fmatrix_allocate_1d(Szw/2);
 float* VctSpectrArc=fmatrix_allocate_1d(Szw/2);
 float* VctSpectrBij=fmatrix_allocate_1d(Szw/2);
 float* VctSpectrBrc=fmatrix_allocate_1d(Szw/2);

 //>Init
 for(i=0;i<Szw;i++) for(j=0;j<Szw;j++)
    { MatSpectrAij[i][j]=0.0;
      MatSpectrArc[i][j]=0.0;
      MatSpectrBij[i][j]=0.0;
      MatSpectrBrc[i][j]=0.0; }
  
 //>DCT
 DCT_Spectrum(ImgA,lgth,wdth,ci,cj,MatSpectrAij,Szw);
 DCT_Spectrum(ImgB,lgth,wdth,ci,cj,MatSpectrBij,Szw);
 DCT_Spectrum(ImgA,lgth,wdth,posr,posc,MatSpectrArc,Szw);
 DCT_Spectrum(ImgB,lgth,wdth,posr,posc,MatSpectrBrc,Szw);
 
 //>Spectrum_Circular_Integration
 for(k=0;k<(Szw/2);k++) VctSpectrAij[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrArc[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrBij[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrBrc[k]=0.0;
 
 CircularInteg(MatSpectrAij,Szw,VctSpectrAij);
 CircularInteg(MatSpectrArc,Szw,VctSpectrArc);
 CircularInteg(MatSpectrBij,Szw,VctSpectrBij);
 CircularInteg(MatSpectrBrc,Szw,VctSpectrBrc);

 //>Distance_(Szw=8:16)
 distA=0.0;
 for(k=0;k<(Szw/2);k++) distA+=fabs(VctSpectrAij[k]-VctSpectrArc[k]);
 distB=0.0;
 for(k=0;k<(Szw/2);k++) distB+=fabs(VctSpectrBij[k]-VctSpectrBrc[k]);
 if (!Flg) dist=fabs(distB-distA);
 if (Flg)  dist=2*MAX(distA,distB)/(MIN(distA,distB)+1);
 //if (Flg)  dist=40*sqrt(1+MAX(distA,distB))/(1+MIN(distA,distB));
 
 //>Distance_(Szw=0)
 if (FlagSzw==1) dist=fabs(fabs(VctSpectrAij[0]-VctSpectrArc[0])-fabs(VctSpectrBij[0]-VctSpectrBrc[0]));
 
 //>FreeMemory
 if (MatSpectrAij) free_fmatrix_2d(MatSpectrAij);
 if (MatSpectrArc) free_fmatrix_2d(MatSpectrArc);
 if (MatSpectrBij) free_fmatrix_2d(MatSpectrBij);
 if (MatSpectrBrc) free_fmatrix_2d(MatSpectrBrc);
 if (VctSpectrAij) free_fmatrix_1d(VctSpectrAij);
 if (VctSpectrArc) free_fmatrix_1d(VctSpectrArc);
 if (VctSpectrBij) free_fmatrix_1d(VctSpectrBij);
 if (VctSpectrBrc) free_fmatrix_1d(VctSpectrBrc);
 
 //Retour
 return dist;
}

//----------------------------------------------------------
//  MyPairwiseDistanceDCT (step:0.5)
//----------------------------------------------------------
float MyPairwiseDistanceDCT_(float** ImgB,float** ImgA,int ci,int cj,int posr,int posc,int lgth,int wdth,int Szw,int Flg)
{
 int i,j,k;
 float dist,distB,distA;
     
 //>AllocateMemory
 float** MatSpectrAij=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrArc=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrBij=fmatrix_allocate_2d(Szw,Szw);
 float** MatSpectrBrc=fmatrix_allocate_2d(Szw,Szw);
 float* VctSpectrAij=fmatrix_allocate_1d(Szw);
 float* VctSpectrArc=fmatrix_allocate_1d(Szw);
 float* VctSpectrBij=fmatrix_allocate_1d(Szw);
 float* VctSpectrBrc=fmatrix_allocate_1d(Szw);

 //>Init
 for(i=0;i<Szw;i++) for(j=0;j<Szw;j++)
    { MatSpectrAij[i][j]=0.0;
      MatSpectrArc[i][j]=0.0;
      MatSpectrBij[i][j]=0.0;
      MatSpectrBrc[i][j]=0.0; }
 
 //>DCT
 DCT_Spectrum(ImgA,lgth,wdth,ci,cj,MatSpectrAij,Szw);
 DCT_Spectrum(ImgB,lgth,wdth,ci,cj,MatSpectrBij,Szw);
 DCT_Spectrum(ImgA,lgth,wdth,posr,posc,MatSpectrArc,Szw);
 DCT_Spectrum(ImgB,lgth,wdth,posr,posc,MatSpectrBrc,Szw);
 
 //>Spectrum_Circular_Integration
 for(k=0;k<(Szw/2);k++) VctSpectrAij[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrArc[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrBij[k]=0.0;
 for(k=0;k<(Szw/2);k++) VctSpectrBrc[k]=0.0;
 
 CircularInteg_(MatSpectrAij,Szw,VctSpectrAij);
 CircularInteg_(MatSpectrArc,Szw,VctSpectrArc);
 CircularInteg_(MatSpectrBij,Szw,VctSpectrBij);
 CircularInteg_(MatSpectrBrc,Szw,VctSpectrBrc);
   
 //>Distance_(Szw=8:16)
 distA=0.0;
 for(k=0;k<Szw;k++) distA+=fabs(VctSpectrAij[k]-VctSpectrArc[k]);
 distB=0.0;
 for(k=0;k<Szw;k++) distB+=fabs(VctSpectrBij[k]-VctSpectrBrc[k]);
 if (!Flg) dist=fabs(distB-distA);
 if (Flg)  dist=2*MAX(distA,distB)/(MIN(distA,distB)+1); 
 
 //>FreeMemory
 if (MatSpectrAij) free_fmatrix_2d(MatSpectrAij);
 if (MatSpectrArc) free_fmatrix_2d(MatSpectrArc);
 if (MatSpectrBij) free_fmatrix_2d(MatSpectrBij);
 if (MatSpectrBrc) free_fmatrix_2d(MatSpectrBrc);
 if (VctSpectrAij) free_fmatrix_1d(VctSpectrAij);
 if (VctSpectrArc) free_fmatrix_1d(VctSpectrArc);
 if (VctSpectrBij) free_fmatrix_1d(VctSpectrBij);
 if (VctSpectrBrc) free_fmatrix_1d(VctSpectrBrc);
 
 //Retour
 return dist;
}

//-----------------//
//---ESTIMATOR----//
//----------------//
//----------------------------------------------------------
// ECI_EG
//----------------------------------------------------------
void ECI_EG(float*** NonLocGr,int nbcnxion,int lgth,int wdth,float HypPar,float** ppar,int sd,float MultPar)
{
 int i,j,k,l,t;
 int posr,posc;
 int Neigh0,Neigh1;
 float alpha;
 float dist,Nrj[2],Proba[2];

 const int MAXITERECI=10;
 const int SzWP=3;

 //>Presentation
 printf("\n > ECI_EG_ [Img<%d:%d>::MultPar=%.3f::Hyp=%.2f](Cnx=%d)",lgth,wdth,MultPar,HypPar,nbcnxion);
 fflush(stdout);

 //>Alpha_Estimation_&_Init
 alpha=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<nbcnxion;k++) alpha+=NonLocGr[2][k][i*wdth+j];
 alpha/=(float)(lgth*wdth*nbcnxion);

 float alpha0=alpha;   
 float alpha1=alpha*2.0; //*2.0 
 float var1=1000;        //=1000 
 printf("\n   Mixture::Exp(alpha0=%.1f)::Gaussian(alpha1=%.1f  var1=%.1f)",alpha0,alpha1,var1);

 //>AllocateMemory_&_Init
 float** MatSeg=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatSeg[i][j]=0.0;

 //>ECI_Loop
 //======================================
 srand(sd);
 for(t=0;t<MAXITERECI;t++)
 {
  //_SIMULATION_STEP_
  //-----------------
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { //:Compute_Nrj_Likelihood
       Nrj[0]=0.0;
       Nrj[1]=0.0;
       for(k=0;k<nbcnxion;k++)
          { posr=NonLocGr[0][k][i*wdth+j]; 
            posc=NonLocGr[1][k][i*wdth+j]; 
            dist=NonLocGr[2][k][i*wdth+j];

	    //Mixture_Exp(alpha0)::Gaussian(alpha1,var1)::[HYP]
            if (MatSeg[posr][posc]==1)
	       { Nrj[0]+=MinusLogfuncgauss(dist,alpha1,var1);
	         Nrj[1]+=MinusLogfuncexpon(dist,alpha0); } 
	    if (MatSeg[posr][posc]==0)
	       { Nrj[0]+=MinusLogfuncexpon(dist,alpha0);   
                 Nrj[1]+=MinusLogfuncgauss(dist,alpha1,var1); }  }
            	    
        Nrj[0]/=nbcnxion;
        Nrj[1]/=nbcnxion;

        //:Compute_Nrj_Prior
        Neigh0=0;
        for(k=0;k<SzWP;k++) for(l=0;l<SzWP;l++)
	   { if ((k==(SzWP/2))&&(l==(SzWP/2))) continue;
	     posr=i-(SzWP/2)+k;
             posc=j-(SzWP/2)+l;
             if (posr<0)          posr+=lgth;
             if (posr>(lgth-1))   posr-=lgth;  
             if (posc<0)          posc+=wdth;
             if (posc>(wdth-1))   posc-=wdth;
	     if (MatSeg[posr][posc]!=0) Neigh0++; }
        Neigh1=((CARRE(SzWP))-1)-Neigh0;

        //:_C_Total_Nrj
        Nrj[0]+=HypPar*Neigh0;
        Nrj[1]+=HypPar*Neigh1;

        //:Label_Choice
        //ComputeProb(Proba,Nrj,1.0);
	ComputeProb(Proba,Nrj,0.15);          //--!!!-Temp=0.15--0.25-!!!! //-NO-MODIF-//
        MatSeg[i][j]=ChooseLabelSA(Proba); }

  //_ESTIMATION_STEP_
  //-----------------
  ML_EG(NonLocGr,nbcnxion,MatSeg,lgth,wdth,ppar);
  //ppar[0][1]=alpha;    //---Constraint !!!!!!!!!!!
  ppar[0][1]=MultPar*alpha;    //---Constraint !!!!!!!!!!!
  printf("\n   %d> [Exp>%.2f::%.1f]-",t,ppar[0][0],ppar[0][1]);
  printf("[Gauss>%.2f::%.1f::%.1f]",ppar[1][0],ppar[1][1],ppar[1][2]);
  alpha0=ppar[0][1];   
  alpha1=ppar[1][1];
  var1=ppar[1][2];
 }

 //>DEBUG
 //Recal(MatSeg,lgth,wdth);
 //SaveImagePgm((char*)"",(char*)"SegECI",MatSeg,lgth,wdth);

 //>Free_Memory
 if (MatSeg) free_fmatrix_2d(MatSeg);
}

//----------------------------------------------------------
// ML_EG
//----------------------------------------------------------
void ML_EG(float*** NonLocGr,int nbcnxion,float** MatSeg,int lgth,int wdth,float** ppar)
{
 int i,j,k;
 int posr,posc;
 long int nb,nb0,nb1;
 float dist;
 float alpha0,mean1,var1;
 float prop0,prop1;

 //>_Maximum_Likelihood_Estimation_
 alpha0=0.0;
 mean1=0.0;
 nb0=nb1=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<nbcnxion;k++)
    { posr=NonLocGr[0][k][i*wdth+j]; 
      posc=NonLocGr[1][k][i*wdth+j]; 
      dist=NonLocGr[2][k][i*wdth+j];
      if (MatSeg[i][j]==MatSeg[posr][posc]) { alpha0+=dist; nb0++; }
      if (MatSeg[i][j]!=MatSeg[posr][posc]) { mean1+=dist;  nb1++; }  }
 alpha0/=(float)nb0;
 mean1/=(float)nb1;
 
 nb=nb0+nb1;
 prop0=(float)nb0/(float)nb;
 prop1=(float)nb1/(float)nb;

 var1=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<nbcnxion;k++)
    { posr=NonLocGr[0][k][i*wdth+j]; 
      posc=NonLocGr[1][k][i*wdth+j]; 
      dist=NonLocGr[2][k][i*wdth+j];
      if (MatSeg[i][j]!=MatSeg[posr][posc]) { var1+=CARRE(dist-mean1); } }
 var1/=(double)nb1;

 //>_Record_
 ppar[0][0]=prop0;
 ppar[0][1]=alpha0;
 ppar[1][0]=prop1;
 ppar[1][1]=mean1;
 ppar[1][2]=var1;

 //>_DEBUG_
 //printf("::::::[Exponential>%.2f::%.1f]--",ppar[0][0],ppar[0][1]);
 //printf("[Gaussian>%.2f::%.1f::%.1f]",ppar[1][0],ppar[1][1],ppar[1][2]);
}

//----------------------------------------------------------
// DiffBetween
//----------------------------------------------------------
float DiffBetween(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 float nb=0;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { if (ImgSegWB[i][j]*ImgGtrWB[i][j]) nb++;
      if ((ImgSegWB[i][j]==0)&&(ImgGtrWB[i][j]==0)) nb++; }

 nb=100*(nb/(lgth*wdth));
 return nb;
}


//-----------//
//--RESULTS--//
//-----------//
//----------------------------------------------------------
// ConfusionMatrix
//----------------------------------------------------------
void ConfusionMatrix(float*** ImgCon,float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth,float* Res)
{
 int i,j;
 long int TN,TP,FP,FN;
 float pTN,pTP,pFP,pFN;
 float Prec;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=FP=FN=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j]))
        { ImgCon[0][i][j]=255;
	  ImgCon[1][i][j]=255;
	  ImgCon[2][i][j]=255;
	  TN++; }

     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j]))
        { ImgCon[0][i][j]=255;
	  ImgCon[1][i][j]=0;
	  ImgCon[2][i][j]=0;
	  TP++; }

     //>--FP--
     if ((!ImgGtrWB[i][j])&&(ImgSegWB[i][j]))
        { ImgCon[0][i][j]=0;
	  ImgCon[1][i][j]=0;
	  ImgCon[2][i][j]=255;
	  FP++; }

     //>--FN--
     if ((ImgGtrWB[i][j])&&(!ImgSegWB[i][j]))
        { ImgCon[0][i][j]=0;
	  ImgCon[1][i][j]=255;
	  ImgCon[2][i][j]=255;
	  FN++; } }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 pFP=100.0*(float)FP/(float)NbPix;
 pFN=100.0*(float)FN/(float)NbPix;
 Res[0]=pTN;
 Res[1]=pTP;
 Res[2]=pFP;
 Res[3]=pFN;
 Prec=pTN+pTP;
 printf("\n > [TN=%.3f][TP=%.3f][FP=%.3f][FN=%.3f]>>[%.5f]",pTN,pTP,pFP,pFN,Prec);
 fflush(stdout);
}

//----------------------------------------------------------
// F-Measure
//----------------------------------------------------------
float FMeasure(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 long int TN,TP,FP,FN;
 float pTN,pTP,pFP,pFN;
 float Prec;
 float Precision,Recall,FMeasure;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=FP=FN=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) TN++;
     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j])) TP++;
     //>--FP--
     if ((!ImgGtrWB[i][j])&&(ImgSegWB[i][j])) FP++;
     //>--FN--
     if ((ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) FN++;  }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 pFP=100.0*(float)FP/(float)NbPix;
 pFN=100.0*(float)FN/(float)NbPix;
 Prec=pTN+pTP;
 if (0)printf("\n > [TN=%.3f][TP=%.3f][FP=%.3f][FN=%.3f]>>[%.5f]",pTN,pTP,pFP,pFN,Prec);
 Precision=(float)TP/((float)TP+(float)FP);
 Recall=(float)TP/((float)TP+(float)FN);
 FMeasure=(2*Precision*Recall)/(Precision+Recall);
 printf("\n > [Precision=%.3f][Recall=%.3f]>>[Fmeasure=%.3f]",Precision,Recall,FMeasure);
 fflush(stdout);
 return FMeasure;
}

//----------------------------------------------------------
// Precision
//----------------------------------------------------------
float Precis(float** ImgSegWB,float** ImgGtrWB,int lgth,int wdth)
{
 int i,j;
 long int TN,TP;
 float pTN,pTP;
 float Precision;
 int NbPix;
 
 //_Main_loop_
 //-----------
 TN=TP=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { //>--TN--
     if ((!ImgGtrWB[i][j])&&(!ImgSegWB[i][j])) TN++;
     //>--TP--
     if ((ImgGtrWB[i][j])&&(ImgSegWB[i][j])) TP++;  }

 //>Result
 NbPix=lgth*wdth;
 pTN=100.0*(float)TN/(float)NbPix;
 pTP=100.0*(float)TP/(float)NbPix;
 Precision=pTN+pTP;
 printf(" [Precision=%.3f]",Precision);
 fflush(stdout);
 return Precision;
}

//----------------------------------------------------------
// Simulated_Annealing
// optimise Version -5-
//----------------------------------------------------------
float SimAnealing_EG_5(float*** NonLocGr,int nbcnxion,float** MatSeg,int lgth,int wdth,\
		    float HypPar,float CoolRate,float** MatSegInit,int sd,float** ppar)
{
 int i,j,k,l,t;
 int posr,posc;
 int NbDifLabels;
 int Neigh0,Neigh1;
 int NbIter;
 float Temp,dist,NrjGlob;
 float Nrj[2];
 float Proba[2];
 float Tinit=1.25;
 float Tfinal=0.01;
 
 const int SzWP=3;
 const int SzWPD2=1;
 const int CARRESzWP=9;
 const int NBITERVISU=1000;  

 //>Mixture_Exp(alpha0)::Gaussian(alpha1,var1)
 float alpha0=ppar[0][1];  
 float alpha1=ppar[1][1];  
 float var1=ppar[1][2]; 
 printf("\n   Mixture::Exp(alpha0=%.1f)::Gaussian(alpha1=%.1f  var1=%.1f)",alpha0,alpha1,var1);

 //>Presentation
 NbIter=(int)((log(Tfinal/Tinit))/log(CoolRate));
 printf("\n > Simul_Annealing_EG [Img<%d:%d>::Cnx=%d::CoolRate=%.6f]",lgth,wdth,nbcnxion,CoolRate);
 printf("\n   Prior[%d::%.2f]_Likelihood_%.1f::[%.1f::%.1f]",SzWP,HypPar,alpha0,alpha1,var1);
 printf("___NbIters:%d [%.2f>%.2f]",NbIter,Tinit,Tfinal);
 fflush(stdout);

 //>AllocationMemory
 float** MatSeg_=fmatrix_allocate_2d(lgth,wdth);
 float*** MatNrjPC=fmatrix_allocate_3d(lgth,wdth,2*nbcnxion);
 float*** NonLocGr2=fmatrix_allocate_3d(lgth*wdth,nbcnxion,3);

 //>Init_Memory
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<nbcnxion*2;k++) MatNrjPC[i][j][k]=0.0;

 //>SA_Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { if (MatSegInit[i][j])  MatSeg[i][j]=1;
       else MatSeg[i][j]=0; }

 //>PreCalcul_NRJ
 //--------------------------
 printf("\n > PreCalcul ...");
 fflush(stdout);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { for(k=0;k<nbcnxion;k++)
          { posr=NonLocGr[0][k][i*wdth+j]; 
            posc=NonLocGr[1][k][i*wdth+j]; 
            dist=NonLocGr[2][k][i*wdth+j];
            NonLocGr2[i*wdth+j][k][0]=posr;
	    NonLocGr2[i*wdth+j][k][1]=posc;
	    NonLocGr2[i*wdth+j][k][2]=dist;
            MatNrjPC[i][j][(2*k)]=MinusLogfuncexpon(dist,alpha0);
            MatNrjPC[i][j][(2*k)+1]=MinusLogfuncgauss(dist,alpha1,var1); } }
 //--------------------------
 
 
 //>SA_Loop
 //======================================
 srand(sd);
 for(t=0;;t++)
 {
  if (t%NBITERVISU==0) CopyMat(MatSeg_,MatSeg,lgth,wdth);

  //:Temperature
  Temp=Tinit*pow(CoolRate,t);

  //:For_Each_Pixel
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { //:Compute_Nrj_Likelihood
       Nrj[0]=0.0;
       Nrj[1]=0.0;
       for(k=0;k<nbcnxion;k++)
          {
	    posr=NonLocGr2[i*wdth+j][k][0]; 
            posc=NonLocGr2[i*wdth+j][k][1]; 
            dist=NonLocGr2[i*wdth+j][k][2];

	    //posr=NonLocGr[0][k][i*wdth+j]; 
            //posc=NonLocGr[1][k][i*wdth+j]; 
            //dist=NonLocGr[2][k][i*wdth+j];

	    //-->Mixture_Exp(alpha0)::Gaussian(alpha1,var1)::[HYP=0.1]
            //if (MatSeg[posr][posc]==1)
	    //   { Nrj[0]+=MinusLogfuncgauss(dist,alpha1,var1);
	    //     Nrj[1]+=MinusLogfuncexpon(dist,alpha0); } 
	    //if (MatSeg[posr][posc]==0)
	    //   { Nrj[0]+=MinusLogfuncexpon(dist,alpha0);   
            //     Nrj[1]+=MinusLogfuncgauss(dist,alpha1,var1); }  }

	    //-->Mixture_Exp(alpha0)::Gaussian(alpha1,var1)::[HYP=0.1]
	    if (MatSeg[posr][posc]) //(==1)
	       { Nrj[0]+=MatNrjPC[i][j][(2*k)+1];
	    	 Nrj[1]+=MatNrjPC[i][j][(2*k)]; }
	    else //if (MatSeg[posr][posc]==0)
	       { Nrj[0]+=MatNrjPC[i][j][(2*k)];
	    	 Nrj[1]+=MatNrjPC[i][j][(2*k)+1]; } }
       	    
        Nrj[0]/=nbcnxion;
        Nrj[1]/=nbcnxion;

        //:Compute_Nrj_Prior
        Neigh0=0;
        for(k=0;k<SzWP;k++) for(l=0;l<SzWP;l++)
	   { if ((k==(SzWPD2))&&(l==(SzWPD2))) continue;
	     posr=i-(SzWPD2)+k;
             posc=j-(SzWPD2)+l;
             if (posr<0)          posr+=lgth;
             if (posr>(lgth-1))   posr-=lgth;  
             if (posc<0)          posc+=wdth;
             if (posc>(wdth-1))   posc-=wdth;
	     if (MatSeg[posr][posc]!=0) Neigh0++; }
        Neigh1=(CARRESzWP-1)-Neigh0;

        //:_C_Total_Nrj
        Nrj[0]+=HypPar*Neigh0;
        Nrj[1]+=HypPar*Neigh1;

        //:Label_Choice
        ComputeProb(Proba,Nrj,Temp);
        MatSeg[i][j]=ChooseLabelSA(Proba);
	}

     //:Stop_Criterion
  if (t%NBITERVISU==0)
     { NrjGlob=NRJ_EG(NonLocGr,nbcnxion,lgth,wdth,alpha0,alpha1,var1,HypPar,MatSeg);
       NbDifLabels=DiffMatNb(MatSeg,MatSeg_,lgth,wdth);
       printf("\n  [It=%d::Temp=%.3f]> [Nrj:%.1f] [Dif:%d]",t,Temp,NrjGlob,NbDifLabels);
       fflush(stdout);
       if (Temp<Tfinal) break; }
 }

 //:Final_NRJ
 NrjGlob=NRJ_EG(NonLocGr,nbcnxion,lgth,wdth,alpha0,alpha1,var1,HypPar,MatSeg);
 printf("\n  [Nrj:%.1f]",NrjGlob);

 //>Inversion?
 NbDifLabels=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatSeg[i][j]) NbDifLabels++;
 if (NbDifLabels>((lgth*wdth)/2))
    { printf("\n > INVERSION");
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
	 { if (MatSeg[i][j]==0) MatSeg[i][j]=1;
	   else MatSeg[i][j]=0; } }

 //>Free_Memory
 if (MatSeg_)  free_fmatrix_2d(MatSeg_);
 if (MatNrjPC) free_fmatrix_3d(MatNrjPC,lgth);
 if (NonLocGr2) free_fmatrix_3d(NonLocGr2,lgth*wdth);

 //>Return
 return NrjGlob;
 }


//----------------------------------------------------------
// Simulated_Annealing
// optimise Version -6-
//----------------------------------------------------------
float SimAnealing_EG_6(float*** NonLocGr,int nbcnxion,float** MatSeg,int lgth,int wdth,\
		    float HypPar,float CoolRate,float** MatSegInit,int sd,float** ppar)
{
 int i,j,k,l,t;
 int posr,posc;
 int NbDifLabels;
 int Neigh0,Neigh1;
 int NbIter;
 float Temp,dist,NrjGlob;
 float Nrj[2];
 float Proba[2];
 float Tinit=1.25;
 float Tfinal=0.01;
 
 const int SzWP=3;
 const int SzWPD2=1;
 const int CARRESzWP=9;
 const int NBITERVISU=1000;  

 //>Mixture_Exp(alpha0)::Gaussian(alpha1,var1)
 float alpha0=ppar[0][1];  
 float alpha1=ppar[1][1];  
 float var1=ppar[1][2]; 
 printf("\n   Mixture::Exp(alpha0=%.1f)::Gaussian(alpha1=%.1f  var1=%.1f)",alpha0,alpha1,var1);

 //>Presentation
 NbIter=(int)((log(Tfinal/Tinit))/log(CoolRate));
 printf("\n > Simul_Annealing_EG [Img<%d:%d>::Cnx=%d::CoolRate=%.6f]",lgth,wdth,nbcnxion,CoolRate);
 printf("\n   Prior[%d::%.2f]_Likelihood_%.1f::[%.1f::%.1f]",SzWP,HypPar,alpha0,alpha1,var1);
 printf("___NbIters:%d [%.2f>%.2f]",NbIter,Tinit,Tfinal);
 printf("___MySeed:%d",sd);
 fflush(stdout);

 //>AllocationMemory
 float** MatSeg_=fmatrix_allocate_2d(lgth,wdth);
 float*** MatNrjPC=fmatrix_allocate_3d(lgth,wdth,2*nbcnxion);
 float*** NonLocGr2=fmatrix_allocate_3d(lgth*wdth,nbcnxion,3);

 //>Init_Memory
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<nbcnxion*2;k++) MatNrjPC[i][j][k]=0.0;

 //>SA_Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { if (MatSegInit[i][j])  MatSeg[i][j]=1;
       else MatSeg[i][j]=0; }

 //>PreCalcul_NRJ
 //--------------------------
 printf("\n > PreCalcul ...");
 fflush(stdout);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { for(k=0;k<nbcnxion;k++)
          { posr=NonLocGr[0][k][i*wdth+j]; 
            posc=NonLocGr[1][k][i*wdth+j]; 
            dist=NonLocGr[2][k][i*wdth+j];
            NonLocGr2[i*wdth+j][k][0]=posr;
	    NonLocGr2[i*wdth+j][k][1]=posc;
	    NonLocGr2[i*wdth+j][k][2]=dist;
            MatNrjPC[i][j][(2*k)]=MinusLogfuncexpon(dist,alpha0);
            MatNrjPC[i][j][(2*k)+1]=MinusLogfuncgauss(dist,alpha1,var1); } }
 //--------------------------
 
 
 //>SA_Loop
 //======================================
 srand(sd);    
 for(t=0;;t++)
 {
  if (t%NBITERVISU==0) CopyMat(MatSeg_,MatSeg,lgth,wdth);

  //:Temperature
  Temp=Tinit*pow(CoolRate,t);

  //:For_Each_Pixel
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { //:Compute_Nrj_Likelihood
       Nrj[0]=0.0;
       Nrj[1]=0.0;
       for(k=0;k<nbcnxion;k++)
          {
	    posr=NonLocGr2[i*wdth+j][k][0]; 
            posc=NonLocGr2[i*wdth+j][k][1]; 
            dist=NonLocGr2[i*wdth+j][k][2];

	    //posr=NonLocGr[0][k][i*wdth+j]; 
            //posc=NonLocGr[1][k][i*wdth+j]; 
            //dist=NonLocGr[2][k][i*wdth+j];

	    //-->Mixture_Exp(alpha0)::Gaussian(alpha1,var1)::[HYP=0.1]
            //if (MatSeg[posr][posc]==1)
	    //   { Nrj[0]+=MinusLogfuncgauss(dist,alpha1,var1);
	    //     Nrj[1]+=MinusLogfuncexpon(dist,alpha0); } 
	    //if (MatSeg[posr][posc]==0)
	    //   { Nrj[0]+=MinusLogfuncexpon(dist,alpha0);   
            //     Nrj[1]+=MinusLogfuncgauss(dist,alpha1,var1); }  }

	    //-->Mixture_Exp(alpha0)::Gaussian(alpha1,var1)::[HYP=0.1]
	    if (MatSeg[posr][posc]) //(==1)
	       { Nrj[0]+=MatNrjPC[i][j][(2*k)+1];
	    	 Nrj[1]+=MatNrjPC[i][j][(2*k)]; }
	    else //if (MatSeg[posr][posc]==0)
	       { Nrj[0]+=MatNrjPC[i][j][(2*k)];
	    	 Nrj[1]+=MatNrjPC[i][j][(2*k)+1]; } }
       	    
        Nrj[0]/=nbcnxion;
        Nrj[1]/=nbcnxion;

        //:Compute_Nrj_Prior
        Neigh0=0;
        for(k=0;k<SzWP;k++) for(l=0;l<SzWP;l++)
	   { if ((k==(SzWPD2))&&(l==(SzWPD2))) continue;
	     posr=i-(SzWPD2)+k;
             posc=j-(SzWPD2)+l;
             if (posr<0)          posr+=lgth;
             if (posr>(lgth-1))   posr-=lgth;  
             if (posc<0)          posc+=wdth;
             if (posc>(wdth-1))   posc-=wdth;
	     if (MatSeg[posr][posc]!=0) Neigh0++; }
        Neigh1=(CARRESzWP-1)-Neigh0;

        //:_C_Total_Nrj
        Nrj[0]+=HypPar*Neigh0;
        Nrj[1]+=HypPar*Neigh1;

        //:Label_Choice
        ComputeProb(Proba,Nrj,Temp);
        //-1-
        MatSeg[i][j]=ChooseLabelSA(Proba);
	//-2-
	//if (Flip(Proba[0])) { MatSeg[i][j]=0; }     //int Flip(float p) { if(randomize()<=p) return(1); return(0); }
	//else MatSeg[i][j]=1;
	//-3-
	//if (randomize()<=Proba[0]) { MatSeg[i][j]=0; }
	//else MatSeg[i][j]=1;	
	}

     //:Stop_Criterion
  if (t%NBITERVISU==0)
     { NrjGlob=NRJ_EG(NonLocGr,nbcnxion,lgth,wdth,alpha0,alpha1,var1,HypPar,MatSeg);
       NbDifLabels=DiffMatNb(MatSeg,MatSeg_,lgth,wdth);
       printf("\n  [It=%d::Temp=%.3f]> [Nrj:%.1f] [Dif:%d]",t,Temp,NrjGlob,NbDifLabels);
       fflush(stdout);
       if (Temp<Tfinal) break; }
 }

 //:Final_NRJ
 NrjGlob=NRJ_EG(NonLocGr,nbcnxion,lgth,wdth,alpha0,alpha1,var1,HypPar,MatSeg);
 printf("\n  [Nrj:%.1f]",NrjGlob);

 //>Inversion?
 NbDifLabels=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (MatSeg[i][j]) NbDifLabels++;
 if (NbDifLabels>((lgth*wdth)/2))
    { printf("\n > INVERSION");
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
	 { if (MatSeg[i][j]==0) MatSeg[i][j]=1;
	   else MatSeg[i][j]=0; } }

 //>Free_Memory
 if (MatSeg_)  free_fmatrix_2d(MatSeg_);
 if (MatNrjPC) free_fmatrix_3d(MatNrjPC,lgth);
 if (NonLocGr2) free_fmatrix_3d(NonLocGr2,lgth*wdth);

 //>Return
 return NrjGlob;
 }
