//------------------------------------------------------
// module  : FunctionMCD.h
// auteur  : Redha Touati and Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>
#include <sys/resource.h>

#include "MCD.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255
#define BIGNUMBER 100000000
#define TROIS 3
#define NCHAR 200

#define CARRE(X) ((X)*(X))
#define SWAP(a,b)  { float tmpp=(a); (a)=(b); (b)=tmpp; }
#define MAX(i,j)  ((i)>(j)?(i):(j))
#define MIN(i,j)  ((j)>(i)?(i):(j))

//------------------------------------------------
// FunctionMCD.cc
//------------------------------------------------
//>MatrixAllocation
float*            fmatrix_allocate_1d(int);
float*            fmatrix_allocate_1d(long int);
float**           fmatrix_allocate_2d(int,int);
float***          fmatrix_allocate_3d(int,int,int);
int*              imatrix_allocate_1d(int);
int**             imatrix_allocate_2d(int,int);
void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);

//>MatrixGestion
void  CopyMat(float**,float**,int,int);
void  Recal(float**,int,int); 
int   DiffMatNb(float**,float**,int,int);

//>Load/SaveFile
void GetLengthWidth(char*,int*,int*);
void LoadImagePpm(char*,float***,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
void SaveImagePpm(char*,char*,float***,int,int);

//>Random
float randomize(void);

//>Graph
void CompNonLocGraph2(float**,float**,float***,int,int,int,int,int);

//>NRJ
float NRJ_EG(float***,int,int,int,float,float,float,float,float**);
float funcgauss(float,float,float,float);
float MinusLogfuncgauss(float,float,float);
float funcexpon(float,float,float);
float MinusLogfuncexpon(float,float);

//>SimulatedAnnealing
int Flip(float);
void ComputeProb(float*,float*,float);
float ChooseLabelSA(float*);

//>SizeReduction
void Multires(float**,int,int,float**,int);
void DecreasedSize(float***,float***,float***,int*,int*,int*);
void DecreasedSizeByTwo(float***,float***,float***,int*,int*,int*);
  
//>Histo_Manip
void Compute_histo(float**,int,int,float*);
void SpecifHisto(float**,int,int,float**,int,int);
void DoubleSpecifHisto(float**,float**,int,int);

//>DCT
void ddct16x16s(int,float**);
void DCT_Spectrum(float**,int,int,int,int,float**,int);
float BilinearInterp(float**,int,int,float,float);
void CircularInteg(float**,int,float*);
void CircularInteg_(float**,int,float*);
float MyPairwiseDistanceDCT(float**,float**,int,int,int,int,int,int,int,int);
float MyPairwiseDistanceDCT_(float**,float**,int,int,int,int,int,int,int,int);

//>Estimator
void ECI_EG(float***,int,int,int,float,float**,int,float);
void ML_EG(float***,int,float**,int,int,float**);
float DiffBetween(float**,float**,int,int);

//>Result
void ConfusionMatrix(float***,float**,float**,int,int,float*);
float FMeasure(float**,float**,int,int);
float Precis(float**,float**,int,int);

//>SA
float SimAnealing_EG_5(float***,int,float**,int,int,float,float,float**,int,float**);
float SimAnealing_EG_6(float***,int,float**,int,int,float,float,float**,int,float**);
