//---------------------------------------------------
// module  : MCD.h                         
// auteur  : Redha Touati and Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    : DIRO                                 
//---------------------------------------------------

#ifndef MCD_H
#define MCD_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionMCD.h"
#include "Chrono.h"

//------------------------------------------------
// CONSTANTES  -----------------------------------
//------------------------------------------------

//>MCD_MODEL_PARAMETER
//--------------------
const float MULT_PAR=1.5;
const float HYP_PAR=0.10;
const int SZNEIGHWIND=41;

const int MAXLGTHIMG=450;
//--------------------

//>MODEL_OTHER_PARAMETER
const int NBCNXGRAPH=8;  
const float PARAM1=0;

//>MODEL_VISU
const int ZOOM=1;
const int SAVE=0;
const int VISU=1;
const int QUIT=0;

//------------------------------------------------
// MCD CLASS----------------------------------
//------------------------------------------------
class MCD
{
  public:
  
  //>Parameters
  float MultPar;
  float HypPar;
  int SzNeighWnd;
  //------------

  //Imgs_&_Matrix_&_Graph
  float*** MatImgBef;
  float*** MatImgAft;
  float*** MatImgGtr;
  float*** MatImgSeg;
  float*** MatImgCon;
  
  float** MatImgBefWB;
  float** MatImgAftWB;
  float** MatImgGtrWB;
  float** MatImgSegWB;
  float** MatImgIniWB;

  float** ParExpDistMixt;

  float*** NonLocalGraph; 

  //Parameters
  int width,length;
  int SzwVctPairObs;

  //ColorInfo
  int FlgColorImgB;
  int FlgColorImgA;

  //Measure
  float fmeasure;
  float precision;
  float nrj;
  int elptime;

  //Info
  char InfoCD[200];
  char MyCom[200];
  char NameImg[100];
  
  //Methods
  public:
  MCD(float***,float***,float***,int,int,char*,float,float,int);
  ~MCD();

  void DetectionMCD(); 
};

#endif 
