//---------------------------------------------------
// module  : f_MCD.cc                       
// auteur  : Redha Touati and Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    : DIRO                                 
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "MCD.h"

//------------------------------------------------
// METHODES DE LA CLASSE MCD  --------------------
//------------------------------------------------
//----------------------------------------------------------
// MCD constructor
//----------------------------------------------------------
MCD::MCD(float*** imgbef,float*** imgaft,float*** imggtr,int lgth,int wdth,\
	 char* NmImg,float Mult_Par,float Hyp_Par,int Sz_NeighWnd)           
 {
  int i,j,k;

  //>Initialization
  MultPar=Mult_Par;
  HypPar=Hyp_Par;
  SzNeighWnd=Sz_NeighWnd;
  
  length=lgth;
  width=wdth;
  strcpy(NameImg,NmImg);
  
  //>Memory_Allocation 
  MatImgBef=fmatrix_allocate_3d(TROIS,length,width);
  MatImgAft=fmatrix_allocate_3d(TROIS,length,width);
  MatImgGtr=fmatrix_allocate_3d(TROIS,length,width);
  MatImgSeg=fmatrix_allocate_3d(TROIS,length,width);
  MatImgCon=fmatrix_allocate_3d(TROIS,length,width);
  MatImgBefWB=fmatrix_allocate_2d(length,width);
  MatImgAftWB=fmatrix_allocate_2d(length,width);
  MatImgGtrWB=fmatrix_allocate_2d(length,width);
  MatImgSegWB=fmatrix_allocate_2d(length,width);
  MatImgIniWB=fmatrix_allocate_2d(length,width);

  NonLocalGraph=fmatrix_allocate_3d(TROIS,NBCNXGRAPH,length*width);
  ParExpDistMixt=fmatrix_allocate_2d(2,3);

  //>Init_&_LoadMatrix
  for(k=0;k<TROIS;k++) for(i=0;i<length;i++) for(j=0;j<width;j++) 
     { MatImgBef[k][i][j]=imgbef[k][i][j];     
       MatImgAft[k][i][j]=imgaft[k][i][j];
       MatImgGtr[k][i][j]=imggtr[k][i][j];
       MatImgSeg[k][i][j]=0.0;
       MatImgCon[k][i][j]=0.0; }

  //>Flag_COLOR_Img
  FlgColorImgB=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgBef[1][i][j]!=MatImgBef[2][i][j]) { FlgColorImgB=1; }
  FlgColorImgA=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgAft[0][i][j]!=MatImgAft[2][i][j]) { FlgColorImgA=1; }
  if (FlgColorImgB) printf(" [Image_Before_In_Color]");
  if (FlgColorImgA) printf(" [Image_After_In_Color]");
  if ((FlgColorImgB==0)&&(FlgColorImgA==0)) printf(" [Image_Before_&_After_In_GreyScale]");
  printf("\n Parameters::[MultPar=%.3f][HypPar=%.3f][SzNeighWnd=%d]",MultPar,HypPar,SzNeighWnd);
  printf("\n");


  //>Color-GreyScale Conversion
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=((1.0/3.0)*MatImgBef[0][i][j])+((1.0/3.0)*MatImgBef[1][i][j])+((1.0/3.0)*MatImgBef[2][i][j]);
      MatImgAftWB[i][j]=((1.0/3.0)*MatImgAft[0][i][j])+((1.0/3.0)*MatImgAft[1][i][j])+((1.0/3.0)*MatImgAft[2][i][j]); }

  for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgIniWB[i][j]=0;
  				  

   //>Initialization_NonLocalGraph
   for(i=0;i<length;i++) for(j=0;j<width;j++) for(k=0;k<NBCNXGRAPH;k++)
    { NonLocalGraph[0][k][i*width+j]=0; 
      NonLocalGraph[1][k][i*width+j]=0; 
      NonLocalGraph[2][k][i*width+j]=0; }
  
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgGtrWB[i][j]=MatImgGtr[0][i][j];
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgSegWB[i][j]=0;

   //DEBUG
   //SaveImagePgm((char*)"",(char*)"GtrWB",MatImgGtrWB,length,width);
   //SaveImagePgm((char*)"",(char*)"BefWB",MatImgBefWB,length,width);
   //SaveImagePpm((char*)"",(char*)"AftWB",MatImgAftWB,length,width);
   //exit(-1);
  
   //>Verif->MatImgGtrWB
   k=0;
   for(i=0;i<length;i++) for(j=0;j<width;j++) if (!((MatImgGtrWB[i][j]==0)||(MatImgGtrWB[i][j]==255))) k++;
   if (k) { printf(" > Probleme: VeriteTerrain avec %d NonWhite || NonBlack pixels\n",k);
            fflush(stdout); }
 
 //Stack_Size_Increased_[128 MB]
 const rlim_t kStackSize=128*1024*1024;   
 struct rlimit rl;
 int result=getrlimit(RLIMIT_STACK,&rl);
 if (result==0)
 if (rl.rlim_cur<kStackSize)
    {  rl.rlim_cur=kStackSize;
       result=setrlimit(RLIMIT_STACK,&rl);
       if (result!=0) fprintf(stderr,"setrlimit returned result = %d\n",result); } 
 }

//----------------------------------------------------------
// MCD destructor
//----------------------------------------------------------
MCD::~MCD()
{ 
  //Memory_Liberation
  if (MatImgBef)  free_fmatrix_3d(MatImgBef,3);
  if (MatImgAft)  free_fmatrix_3d(MatImgAft,3);
  if (MatImgGtr)  free_fmatrix_3d(MatImgGtr,3);
  if (MatImgSeg)  free_fmatrix_3d(MatImgSeg,3);
  if (MatImgCon)  free_fmatrix_3d(MatImgCon,3);
  if (MatImgBefWB)  free_fmatrix_2d(MatImgBefWB);
  if (MatImgAftWB)  free_fmatrix_2d(MatImgAftWB);
  if (MatImgGtrWB)  free_fmatrix_2d(MatImgGtrWB);
  if (MatImgSegWB)  free_fmatrix_2d(MatImgSegWB);
  if (MatImgIniWB)  free_fmatrix_2d(MatImgIniWB);
  if (ParExpDistMixt) free_fmatrix_2d(ParExpDistMixt);
}

//----------------------------------------------------------
// Detection
// ---------
// 1-] __ MPM
// 2-] __ Approche Multiresolution/Multigrille
// 3-]___ Resegmentation apres re-estimation parametre
// 4-] __ Fusion des distances qui marchent
// 5-] __ Bord Nettoye
// 6-] __ Recuit_Simule_GPU
// 7-] __ Modelisation Norme INF
// 8-] __ Modelisation Distance Inverse | |ys(t1)-ys(t2)| - |yt(t1)-yt(t2)| |
// 9-] __ Double Histogramme Matching
//
//
//
// Parametres:
// -----------
//   ---->(*) MultPar::Fact du parametre exponentiel [1.5]
//   ---->(*) HYP (Hyperparameter) [0.10]
//   ---->(*)(*) Longueur Graph [41]
//   ---->(*)(*) Temp. de l'ECI ? (=! 0.25>[0.15])
//   ---->(*) DecreasedSize (1+ ?) > NON
//   ---->(*)(*) Init des parametre de ECI ? (*2 & 1000) > NON
//
// Optimisation
// ------------
//   (*) Rassembler code
//   (*) Liberation memoire ancien graph
//   (*) Table d'Exponentiel
//
//----------------------------------------------------------
void MCD::DetectionMCD()
{
  int k;
  Chrono chrono;
  
  //>---[1]---
  printf("\n [1] _Load_Graph_&_Pairwise_Observation_Vector_[%s]::[LongGrph=%d]",NameImg,SzNeighWnd);
  chrono.reset(); 
  DoubleSpecifHisto(MatImgBefWB,MatImgAftWB,length,width);
  CompNonLocGraph2(MatImgBefWB,MatImgAftWB,NonLocalGraph,length,width,SzNeighWnd,16,0); //--Ok-[DCT-16]-->
  
  //>---[2]---
  printf("\n\n [2] _Estimation_Step_[%s]::[MultPar=%.3f][HypPar=%.3f]",NameImg,MultPar,HypPar);
  ECI_EG(NonLocalGraph,NBCNXGRAPH,length,width,HypPar,ParExpDistMixt,1,MultPar);

  //>---[3]---
  printf("\n\n [3] _Segmentation_Step_[%s]::[HypPar=%.3f]",NameImg,HypPar);
  for(int i=0;i<length;i++) for(int j=0;j<width;j++) MatImgIniWB[i][j]=(int)(randomize()+0.5);  //--Ok-[Random_Init]--> 
  //for(int i=0;i<length;i++) for(int j=0;j<width;j++) MatImgIniWB[i][j]=0; 
  //float CoolRate=0.99; //---> 
  //float CoolRate=0.999; //--->
  //float CoolRate=0.9999; //--->
  //float CoolRate=0.99995; //--->  
  float CoolRate=0.999975; //--->0K-[SA_0.999975]-->
  nrj=SimAnealing_EG_5(NonLocalGraph,NBCNXGRAPH,MatImgSegWB,length,width,HypPar,CoolRate,MatImgIniWB,1,ParExpDistMixt); 
  //nrj=SimAnealing_EG_6(NonLocalGraph,NBCNXGRAPH,MatImgSegWB,length,width,HypPar,CoolRate,MatImgIniWB,4,ParExpDistMixt); //--NO-MODIF--//
  printf("\n Diff=%.3f",DiffBetween(MatImgSegWB,MatImgGtrWB,length,width));
  Recal(MatImgSegWB,length,width);
  for(k=0;k<3;k++) CopyMat(MatImgSeg[k],MatImgSegWB,length,width);

  //>---[4]---
  printf("\n\n [4] _Result_Step_[%s]",NameImg);
  printf("\n");
  elptime=chrono.elapsed(SECOND);
  chrono.print();
  float* Result=fmatrix_allocate_1d(4);
  ConfusionMatrix(MatImgCon,MatImgSegWB,MatImgGtrWB,length,width,Result);
  fmeasure=FMeasure(MatImgSegWB,MatImgGtrWB,length,width);
  precision=Precis(MatImgSegWB,MatImgGtrWB,length,width);
  sprintf(InfoCD,"%s_%s_SA999975_Fm%.2f_Pr%.2f_Nrj%.0f_Time%d",NameImg,MyCom,fmeasure,precision,nrj,elptime); //-Ok-[Com]->
  //sprintf(InfoCD,"%s_%s_ICM_Fm%.2f_Pr%.2f_Nrj%.0f_Time%d",NameImg,MyCom,fmeasure,precision,nrj,elptime);
  printf("\n > FMeasure=%.3f  Precision=%.1f  Nrj=%.0f (%s)",fmeasure,precision,nrj,InfoCD);
  ML_EG(NonLocalGraph,NBCNXGRAPH,MatImgSegWB,length,width,ParExpDistMixt); //**//
  printf("\n > Re-estimated Mixture::Exp(p=%.2f alpha0=%.1f)::",ParExpDistMixt[0][0],ParExpDistMixt[0][1]);  //**//
  printf("Gauss(p=%.2f alpha1=%.1f var1=%.0f)",ParExpDistMixt[1][0],ParExpDistMixt[1][1],ParExpDistMixt[1][2]);  //**//
   
  //>Sauve
  SaveImagePpm(InfoCD,(char*)"_SegConfus",MatImgCon,length,width);
  SaveImagePgm(InfoCD,(char*)"_SegResult",MatImgSegWB,length,width); 
}
